# 
#
# Generated by dumpDCWorkflow.py written by Sebastien Bigaret
# Original workflow id/title: event_signer_workflow/Event Signer Workflow [SignableEvent]
# Date: 2007/06/05 18:02:41.117 GMT+2
#
# WARNING: this dumps does NOT contain any scripts you might have added to
# the workflow, IT IS YOUR RESPONSABILITY TO MAKE BACKUPS FOR THESE SCRIPTS.
#
# No script detected in this workflow
# 
"""
Programmatically creates a workflow type
"""
__version__ = "$Revision: 23 $"[11:-2]

from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

def setupEvent_signer_workflow(wf):
    "..."
    wf.setProperties(title='Event Signer Workflow [SignableEvent]')

    for s in ['initial', 'valid']:
        wf.states.addState(s)
    for t in ['validate']:
        wf.transitions.addTransition(t)
    for v in ['action', 'review_history', 'actor', 'comments', 'time']:
        wf.variables.addVariable(v)
    for l in ['reviewer_queue']:
        wf.worklists.addWorklist(l)
    for p in ('Access contents information', 'Modify portal content', 'View'):
        wf.addManagedPermission(p)
        

    ## Initial State
    wf.states.setInitialState('initial')

    ## States initialization
    sdef = wf.states['initial']
    sdef.setProperties(title="""""",
                       transitions=('validate',))
    sdef.setPermission('Access contents information', 0, ['Anonymous', 'Authenticated'])
    sdef.setPermission('Modify portal content', 0, ['Anonymous', 'Authenticated'])
    sdef.setPermission('View', 0, ['Anonymous', 'Authenticated'])

    sdef = wf.states['valid']
    sdef.setProperties(title="""""",
                       transitions=())
    sdef.setPermission('Access contents information', 0, ['Manager'])
    sdef.setPermission('Modify portal content', 0, ['Manager'])
    sdef.setPermission('View', 0, ['Manager'])


    ## Transitions initialization
    tdef = wf.transitions['validate']
    tdef.setProperties(title="""""",
                       new_state_id="""valid""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""validate""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props=None,
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    ## Worklists Initialization
    ldef = wf.worklists['reviewer_queue']
    ldef.setProperties(description="""Reviewer tasks""",
                       actbox_name="""Pending (%(count)d)""",
                       actbox_url="""%(portal_url)s/search?review_state=pending""",
                       actbox_category="""global""",
                       props={'guard_permissions': 'Review portal content', 'var_match_review_state': 'pending'})

def create_workflow(id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupEvent_signer_workflow(ob)
    return ob

